<?php

//Add the following to your DataObject you want to attache the Review too

static $has_many = array (
	'Reviews' => 'Review',
);


$reviewManager = new DataObjectManager(
	$this,
	'Reviews',
	'Review',
	array(
		  'Created' => 'Date',
		  'Name' => 'Name',
		  'Email' => 'Email',
		  'Title' => 'Title',
		  'Location' => 'Location',
		  'Rating' => 'Rating',
		  'Review' => 'Review',
		  'Approval' => 'Approval'
		  ),
	'getCMSFields_forPopup',
	'',
	'Date'
);

$fields->addFieldToTab("Root.Content.Reviews", $reviewManager);

//This Function Calculates Average Rating of Approved Reviews

function AverageRating() {
	 $records = DataObject::get("Review","Approval = 1 AND ProductID =" . $this->ID);
	 if(!$records) {
		 return false;
	 }
	 else
	 {
	 $ratingArray = $records->column('Rating');
	 $totalRatingsCount = $records->Count();
	 $totalRatingSum = array_sum($ratingArray);
	 $averageRating = $totalRatingSum/$totalRatingsCount;
	 if ($averageRating >= ($half = ($ceil = ceil($averageRating))- 0.5) + 0.25) return $ceil;
	 else if($averageRating < $half - 0.25) return floor($averageRating);
	 else return $half;
	 }
 }
 
 
 
 
//Following Code goes into your Controller

/**Create Review Form****
************************
************************/
function UserProductReviewForm() {
  // Create fields
  
  
  $fields = new FieldSet(
	 new TextField('Name','Name:'),
	 new EmailField('Email','E-Mail Address:'),
	 new OptionsetField('Rating','Rating',array(
										'1' => '1',
										'2' => '2',
										'3' => '3',
										'4' => '4',
										'5' => '5',
										)
	 ),
	 new TextField('Title','Review Title:'),
	 new TextareaField('Review'),
	 new HiddenField('ProductID', '', $this->ID),
	 new HiddenField('ProductName','',$this->Title)
  );
  // Create actions
  $actions = new FieldSet(
	 new FormAction('doReview', 'Submit')
  );

  return new Form($this, 'UserProductReviewForm', $fields, $actions);
  

}

function doReview($data, $form) {
  $review = new Review();
  $form->saveInto($review);
  $review->write();
  
  //Set data
  $From = "Insert EMail Here";
  $To = "Insert Email Here";
  $Subject = "New Review for " . $data['ProductName'];
  $email = new Email($From, $To, $Subject,$body);
  //set template
  $email->setTemplate('ReviewEmail');
  //populate template
  $email->populateTemplate($data);
  //send mail
  $email->send();
  //return to submitted message
  Director::redirect(Director::baseURL(). "thank-you-for-your-review/");
  //return $this->Mailto;
}